import  java.io.*;
import  java.util.Scanner;

public class Queue {

    static private int size = 10000;
    static private int head;
    static private int tail;
    static private int [] queue;

   public  int readInfo () {
     Scanner in = new Scanner(System.in);    
     System.out.print("Insert value: ");
     int info = in.nextInt();
     return info;
   }

    private  int next (int n) {
	return ((n==queue.length-1) ? 0 : n+1);
    }

    public  void init() {
	head = tail = 0;
	queue = new int[size];
    }

    public  boolean isEmpty() {
	return (head == tail);
    }

    public  boolean isFull() {
        return (next(tail)==head);
    }

    public  void enqueue(int x) {
        if (!isFull()) {
	   queue[tail] = x;
           tail=next(tail);
	}
    }

    public  int dequeue() {
        if (!isEmpty()) {
  	   int t = queue[head];
           head = next(head);
	   return t;
	}
        else
	  return 0;
    }

    public  int head() {
       return queue[head];
    }

    public void print () 
    {
       int i;
       for (i=head;i!=tail;i=next(i)) 
           System.out.printf(" %s ", queue[i]);          
       System.out.println(); 
    }


}
