import  java.io.*;
import  java.util.Scanner;

public class Stack {

    private int count;
    private int size = 10000;
    private int[] stack;

    public void init() {
	count = 0;
	stack = new int[size];
    }

    public boolean isEmpty() {
	return count == 0;
    }

    public void push(int x) {
	stack[count++] = x;
    }

    public int pop() {
	return stack[--count];
    }

    public int top() {
	return stack[count-1];
    }

    public void print() {
	for (int i=0;i<count;i++)
            System.out.printf("%2d",stack[i]);
        System.out.printf("\n");
    }

    public void revPrint() {
	for (int i=count-1;i>=0;i--)
            System.out.printf("%2d",stack[i]);
        System.out.printf("\n");
    }

}
